

# ls  {#concept_303804 .concept}

ls命令用于列举存储空间（Bucket）、对象（Object）。

## 命令格式 {#section_22j_0g5_zxr .section}

``` {#codeblock_iqe_41b_uc4}
./ks3util ls [-b]  [ks3://bucket[/prefix]] [-f] [-d] ] [-marker] [-o] [-u] 
```

## 使用示例 {#section_qz8_3f3_3pp .section}

- [-b 列举桶]列举Bucket
``` {#codeblock_vy0_qp2_0xu}
  ./ks3util ls -b
  
  ========================= Buckets List =========================
  CreationTime         Region    StorageClass    BucketName
  -------------------  --------  ------------  ---------------------  
  2020-08-19 14:45:38  BEIJING   NORMAL          uptooz-test       
  2020-09-01 15:31:22  BEIJING   NORMAL          bucket-1 
  -------------------  --------  ------------  ---------------------  
  Bucket Number is:3
                    
  ```

  

- [读取数据]列举指定Bucket下所有的Object (目前数据可能多 请到输出的文本查看)

``` {#codeblock_tzz_thx_qmu}
./ks3util ls ks3://bucketName   或者  ./ks3util ls ks3://bucketName/prefix

Direction Number is: 0
total num 8 个
total size 291931757 Bytes, 278.41 MB
finish ls command  
```



- [-d 目录形式显示]列举指定Bucket下所有目录或列举某级目录下所有目录(使用 -d 参数文件列表以目录级别形式显示)
``` {#codeblock_tzz_thx_qmu}
  ./ks3util ls ks3://bucketName  -d  ||  ./ks3util ls ks3://bucketName/prefix -d
============= Object  List =============
PrefixDir           ContainsNum  TotalSize
------------------  -----------  ---------  
1                   2            2.20 KB  
目录文件集合              5            280.36 KB
2                   2            2.09 KB  
------------------  -----------  ---------  
Direction Number is:3
total num 9 个
total size 291487 Bytes, 284.66 KB
finish ls command
```

- [-m 游标] 读取 `bucketName`桶下 顺序排在`key1` 这个key之后的所有文件数量和大小
  同时搭配 -m 可指定扫描某个key值之后的对象 搭配 -include -exclude参数 可以指定扫描时的白名单和黑名单
``` {#codeblock_vy0_qp2_0xu}
  ./ks3util ls ks3://bucketName -m key1 -d
  
============= Object  List =============
PrefixDir           ContainsNum  TotalSize
------------------  -----------  ---------  
目录文件集合              3            191.25 KB
------------------  -----------  ---------  
```

- [-k 导出key文本] 读取 `bucketName`桶下所有对象并导出key文本（使用 -k 参数）
  [-o 在导出文本之后添加文件属性]如果需要添加其他属性如：Etag 文件大小，最后修改时间，在之后添加 -o参数即可
  同时搭配 -m 可指定扫描某个key值之后的对象 搭配 -include -exclude参数 可以指定扫描时的白名单和黑名单
``` {#codeblock_vy0_qp2_0xu}
./ks3util ls ks3://bucketName -k key.txt -o
  
Direction Number is: 0
total num 24 个
total size 609758435 Bytes, 581.51 MB
keys file write to /key.txt
finish ls command
```


- [-u 导出临时Url访问文本] 读取 `bucketName`桶下所有对象并导出扫描对象的url临时访问文本（使用 -u 参数）
同时搭配 -m 可指定扫描某个key值之后的对象 搭配 -include -exclude参数 可以指定扫描时的白名单和黑名单
``` {#codeblock_vy0_qp2_0xu}
./ks3util ls ks3://bucketName -u url.txt
  
Direction Number is: 0
total num 24 个
total size 609758435 Bytes, 581.51 MB
keys file write to /key.txt
finish ls command
```

- [-include -exclude 扫描数据的白名单黑名单] 读取 `bucketName`桶下所有对象并设置扫描的白名单和黑名单
  使用-include -exclude参数 可以指定扫描时的白名单和黑名单
  如下 列举bucket桶下所有文件但排除key中包含 `test`的文件 
``` {#codeblock_vy0_qp2_0xu}
./ks3util ls ks3://bucketName -exclude test
  
Direction Number is: 0
total num 6 个
total size 177647275 Bytes, 169.42 MB
finish ls command
```
[匹配规则] 前缀匹配和后缀匹配使用 *作为匹配符  
匹配后缀结尾的使用 `*xxx` 如 匹配以 `.jpg` 结尾的文件 使用 `*.jpg`
匹配前缀的使用 `xxx*` 匹配以 `KS3` 开头的文件 使用 `KS3*`
列举bucket桶下所有文件 但排除文件以 `.jar` 结尾的文件类型
``` {#codeblock_vy0_qp2_0xu}
./ks3util ls ks3://bucketName -exclude *.jar
  
Direction Number is: 0
total num 6 个
total size 177647275 Bytes, 169.42 MB
finish ls command
```




## 常用选项 {#section_u0p_bn4_loi .section}

您可以在使用ls命令时附加如下选项指定列举模式及列举的内容：

| 选项名称    | 描述                                  |  是否必填|有无参数 |
| --------- | ----------------------------------- |------------- |------ |
| `-b`      | 列举所有bucket目录 |否|无参数|
| `-d`      | 返回当前目录下的文件和子目录，而非递归显示所有子目录下的所有Object。 |否|无参数|
| `-m` | 列举Object时的游标marker， 在列举对象时 若填写则只会列举此key值之后的key|否|有参数|
| `-u`      | 输入该值时会导出一份url列表文件                              |否|有参数|
| `-k`      | 输入该值时会导出一份objectKey列表文件                        |否|有参数|
| `-o`      | 仅在输入-k之后生效 会在objectKey列表文件输出文件的基础上增加文件信息            |否|无参数|
| `-include`| 文件名称白名单，多个用英文逗号分隔。                         |否| 有参数|
| `-exclude`| 文件名称黑名单，多个用英文逗号分隔。                         |否|有参数|



